#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <errno.h>

main()
{
  int pid;
  if ((pid = fork()))
    {  /*programma padre */
     int fd_out;
     char device[] = "/dev/ttyS0";
     struct termios term_strutt;
     printf("parent program pid=%d\n",pid);
     if (tcgetattr(0,&term_strutt) < 0)
       {
        perror("tcgetattr");
        return;
       }
     cfmakeraw(&term_strutt);
     if (tcsetattr(0,TCSANOW,&term_strutt) < 0)    
       {
        perror("tcsetattr");
        return;
       }

     if( (fd_out=open(device,O_WRONLY)) < 0)
       {
        perror("open device");
        exit(1);
       }
     if (tcgetattr(fd_out,&term_strutt) < 0)
       {
        perror("tcgetattr");
        return;
       }
     cfmakeraw(&term_strutt);
     if (tcsetattr(fd_out,TCSANOW,&term_strutt) < 0)    
       {
        perror("tcsetattr");
        return;
       }
     while(1) 
     {
      char buffer;

      read(0,&buffer,1);
      write(fd_out,&buffer,1);
      if (buffer == '_') break;
     }
    }
  else 
    {        /* programma figlio */
   int fd_in;
   char device[] = "/dev/ttyS0";
   struct termios term_strutt;
     printf("child program pid=%d\n",pid);

   if( (fd_in=open(device,O_RDONLY)) < 0)
    {
      perror("open device");
      exit(1);
     }
   if (tcgetattr(fd_in,&term_strutt) < 0)
    {
      perror("tcgetattr");
      return;
     }
   cfmakeraw(&term_strutt);
   if (tcsetattr(fd_in,TCSANOW,&term_strutt) < 0)    
    {
      perror("tcsetattr");
      return;
     }
   if (tcgetattr(1,&term_strutt) < 0)
    {
      perror("tcgetattr");
      return;
     }
   cfmakeraw(&term_strutt);
   if (tcsetattr(1,TCSANOW,&term_strutt) < 0)    
    {
      perror("tcsetattr");
      return;
     }
  if (tcgetattr(1,&term_strutt) < 0)
    {
      perror("tcgetattr");
      return;
     }

  while(1) 
   {
    char buffer;

    read(fd_in,&buffer,1);
    write(1,&buffer,1);
    if (buffer == '_') break;
   }
  
  }

}
