struct mat {
             int nx;
             int ny;
             double *m;
            };



struct mat *mat(int nx, int ny)
{
  struct mat *matrice;
  matrice =(struct mat *) calloc(1,sizeof(struct mat));
  matrice->nx = nx;
  matrice->ny = ny;
  matrice->m = (double *)calloc(nx*ny,sizeof(double));
  return matrice;
}


int PutElem(struct mat *a,int i,int j,double value)
{
  if ((i >= 0) && (i < a->nx) && (j >= 0) && (j < a->ny))
    {
     a->m[i*(a->ny)+j]=value;
     return 0;
    }
  else
    return -1;
}
int GetElem(struct mat *a,int i,int j,double *value)
{
  if ((i >= 0) && (i < a->nx) && (j >= 0) && (j < a->ny))
    {
     *value=a->m[i*(a->ny)+j];
     return 0;
    }
  else
    return -1;
}

int print_matrice(struct mat *m)
{
  double value;
  int i,j;
  printf("\n");
  for(i = 0 ; i < m->nx ; i++)
   {
    printf("%d    ",i);
    for (j = 0 ; j < m->ny ; j++)
      {
       GetElem(m,i,j,&value);
       printf("%lg  ",value);
      }
    printf("\n");
   }

}


struct mat *read_matrice()
    {
      int j,k;
      int nx2,ny2;
      double value;
      struct mat *matr;
      printf("righe, colonne? ");
      scanf("%d%d",&nx2,&ny2);
      matr = mat(nx2,ny2);
      printf("Inserisci gli elementi della  matrice \n");
      for(j=0;j < nx2;j++)
       for(k=0;k < ny2; k++)
         {
	  scanf("%lg",&value);
          PutElem(matr,j,k,value);
	  //        printf("%d %d %lg\n",j,k,value);
         }
      matr->nx = nx2;
      matr->ny = ny2;
      return matr;
    }   

struct mat *prodottom(struct mat *matrice1,struct mat *matrice2)
{
  int i,j,k;
  struct mat *matricep;
  printf("%d %d %d %d\n",matrice1->nx,matrice1->ny,matrice2->nx,matrice2->ny);
  if (matrice1->ny == matrice2->nx)
   {
    double value1,value2;
    matricep = mat(matrice1->nx,matrice2->ny);
    for (i = 0 ; i < matrice1->nx ; i++)
      for (k = 0 ; k < matrice2->ny ; k++)
       {
        double sum = 0;
        for (j = 0 ; j < matrice1->ny ; j++)
         {
          GetElem(matrice1,i,j,&value1);
          GetElem(matrice2,j,k,&value2);
          sum += value1*value2;
         }
        PutElem(matricep,i,k,sum);
        printf("%d %d %lg\n",i,k,sum);
       }
    matricep->nx = matrice1->nx;
    matricep->ny = matrice2->ny;
    return matricep;
    }
   else
     return 0;

}

