/*

  m[0][0]
  m[0][1]
........
  m[0][4]
  m[1][0]
  m[1][1]
........
  m[1][4]
  m[2][0]
  m[2][1]


0x10000  1.0   m[0]   
0x10008  2.0   m[1]
0x10010  3.0   m[2]
 
 m 0x10000  &m[0] 0x10000    &m[2]   double *addrm=m;  *(addrm+2)

 &m[i][j]=&matrice[i*nx+j]


*/
struct mat {
             int nx;
             int ny;
             double *m;
            };



struct mat *mat(int nx, int ny)
{
  struct mat *matrice;
  matrice =(struct mat *) calloc(1,sizeof(struct mat));
  matrice->nx = nx;
  matrice->ny = ny;
  matrice->m = (double *)calloc(nx*ny,sizeof(double));
  return matrice;
}


int PutElem(struct mat *a,int i,int j,double value)
{
  if ((i >= 0) && (i < a->nx) && (j >= 0) && (j < a->ny))
    {
     a->m[i*(a->nx)+j]=value;
     return 0;
    }
  else
    return -1;
}
int GetElem(struct mat *a,int i,int j,double *value)
{
  if ((i >= 0) && (i < a->nx) && (j >= 0) && (j < a->ny))
    {
     *value=a->m[i*(a->nx)+j];
     return 0;
    }
  else
    return -1;
}

int print_matrice(struct mat *m)
{
  double value;
  int i,j;
  printf("\n");
  for(i = 0 ; i < m->nx ; i++)
   {
    printf("%d    ",i);
    for (j = 0 ; j < m->ny ; j++)
      {
       GetElem(m,i,j,&value);
       printf("%lg  ",value);
      }
    printf("\n");
   }

}
main()
{
  int nx,ny;
  struct mat *matrice;
  int j,k;
  double value;
  printf("dimensione x,y ? ");
  scanf("%d%d",&nx,&ny);
  
  matrice=mat(nx,ny);

  for (j=0; j < nx ; j++)
    for (k=0 ; k < ny ; k++)
      {
       scanf("%lg",&value);
       PutElem(matrice,j,k,value);
      }
  print_matrice(matrice);
}
