#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <unistd.h>

main(int argc,char **argv)
{
  struct termios termio;
  int fdterm;
  if(*(argv[1]) == '/')
    {
    if((fdterm=open(argv[1],O_RDONLY)) == -1)
      {
       perror("argv[1]");
       exit(1);
      }
    else
      printf("%s open\n",argv[1]);
    }
  else if(*argv[1] == '0' ||*argv[1] == '1' ||*argv[1] == '2') 
    {
      fdterm=*argv[1]-0x30;
      printf("file descriptor=%c\n",*argv[1]);
     }
  else
    {
      printf("no valid file descriptor or device name\n");
      exit(1); 
    }
  if (tcgetattr(fdterm,&termio) == -1)
    {
      perror("get attributes");
      exit(1);
    }
  printf("c_iflag=%11.11o\nc_oflag=%11.11o\nc_cflag=%11.11o\nc_lflag=%11.11o\n",termio.c_iflag,termio.c_oflag,termio.c_cflag,termio.c_lflag);

}
