/* PROGRAMMA CHE PERMETTE DI MEMORIZZARE UN NUMERO CON UN NUMERO DI CIFRE ARBITRARIAMENTE GRANDE E DI SOMMARE DUE DI QUESTI NUMERI*/


#include <stdlib.h> /*contiene i file di intestazione per le funzioni sulle stringhe*/

struct numero
{
  int num_cifre;  /*intero che contiene il numero di  cifre del numero*/
  int segno;      /* intero che contiene il segno del numero*/
  char *cifre;    /* puntatore che contiene il numero vero e proprio, cio memorizzo il numero come una stringa di caratteri,ogni carattere della stringa  una cifra del mio numero; si  messo char e non int in modo che alla fine il mio vettore occuper meno memoria tanto le cifre vanno da 0 a 9 quindi ce la fo tranquillamente con un char*/
};

/*notiamo che un int  un numero a 32 bit quindi num_cifre pu contenere 2 alla 32 cifre */



/*faccio ora la funzione che mi crea la struttura che contiene il numero */

struct numero *crea_num(char *s) /*questa funzione prende in imput la stringa che noi inseriamo da linea di comando e restituisce un puntatore ad una struttura di tipo numero. si lavora con i puntatori e non con le stringhe vere e proprie cperch cos, quando nel main si dovr accedere ai campi della struttura, si dovr passare solo un puntatore e non tutta la stringa e quindi il passaggio sar pi veloce */
{
  
  int j,k;
  struct numero *num;
  num=calloc(1,sizeof(struct numero)); /*in questo modo alloco la memoria per "una" struttura di tipo numero e la metto dentro num. Calloc  una funzione che prende due argomenti in ingresso. Il secondo  la dimensione dell'elemento (espresso in byte) che si vuole mettere in memoria e il primo  un intero che dice quanti degli elemeti espressi nel secondo argomento si vogliono allocare, se non ci si ricorda le dimensioni dell'oggetto basta usare l funzione sizeof  */
  
  for(j=0;s[j]==' ';j++);/* per eliminare gli eventuali spazi bianchi prima del numero immesso da linea di comando*/
  
  /* faccio subito il controllo del segno */
  if(s[j] == '-') 
    {
      num->segno= -1; /* la ->  come dire *(num).segno ,cio accedere al campo segno di num*/
      j++;
    }
  else
    {
      num->segno=1;
      if(s[j] == '+')
	j++;
    }
  
  num->num_cifre=strlen(s)-j;  /*questa  la lunghezza della stringa meno il segno e gli spazi bianchi eventuali, cio  il numero delle cifre del mio numero */
  
  /* adesso abbiamo bisogno di una zona di memoria che mi contenga il numero, cio pari alla memoria di un char per il numero di cifre appena calcolato con strlen*/
  
  num->cifre=calloc(num->num_cifre,sizeof(char));
  
  
  /* adesso vado a riempire la memoria che ho appena allocato */
  
  
  for(k=0;s[j]!=0;k++,j++) /*si  messo s[j]!=0 perch ogni stringa finisce con il carattre null che in ascii  proprio zero */
    num->cifre[k]=s[j];
  return num;
}






/* scriviamo ora una funzioni che calcoli la somma tra due di questi numeroni */


struct numero *sum_num(struct numero *a, struct numero *b) /*ovviamente questa funzione prender in imput i due numeroni e me ne restituir un terzo */
{
  int riporto,j,diff1,diff2;
  struct numero *s;
  s=calloc(1,sizeof(struct numero)); /*alloco la memoria per la struttura che conterr il numero somma dei due in ingresso*/
  if(a->segno == b->segno)
    {
      /*somma*/
      int somma;
      s->segno=a->segno;
      if(a->num_cifre > b->num_cifre)
	s->num_cifre= a->num_cifre +1;
      else 
	s->num_cifre=b->num_cifre+1;
      s->cifre=calloc(s->num_cifre,sizeof(char));
      riporto=0;
      for(j=0; j < s->num_cifre-1 ;j++)
	{
	  somma=0;
	  if (a->num_cifre-j>0)
	    somma += a->cifre[a->num_cifre-1-j]-0x30;
	  if (b->num_cifre-j>0)
	    somma += b->cifre[b->num_cifre-1-j]-0x30;
	  somma += riporto;
	    

	  /* perch i caratteri ascii da zero a 9 corrispondono, in esadecimale, ai numeri da 30 a 39 quindi se ad ogni carattere sottraggo il numero esadecimale 30 ottengo la cifra vera e propria , cio quando si digita il numero 0 in realt a questo corrisponde la sequenza di 8 bit (char) che corrisponde al numero esadecimale 30 quindi se voglio il umero zero in binario basta sottrarre al numero zero digitato il numero 30 esadecimale*/
	  
	  if(somma<=9)
	    {
	      riporto=0;
	      s->cifre[s->num_cifre-1-j]=somma+0x30;
	    }
	  else
	    {
	      riporto=1;/* questo perch se si somma due numeri da 0 a 9 al massimo il riporto  1 perch al massimo posso ottenere 18 quindi scrivo 8 e porto 1 */
	      s->cifre[s->num_cifre-1-j]=somma-10+0x30;
	    }
	}
      if(riporto==1)/* considero ora il fatto che una volta ultimata la somma si possa avere un riporto finale e quindi si considera */
	s->cifre[0]=0x31;/*cifre[0] perch la prima cifra  la pi significativa */
      else
	s->cifre[0]=0x30;
    }


/*provo ora a fare la differenza tra due numeroni*/


  else
    {/*differenza*/ 
      int differenza;
      if(a->num_cifre > b->num_cifre)
	{
	  s->num_cifre = a->num_cifre;
	 
	}
      else
	{
	  s->num_cifre = b->num_cifre;
	
	}
      s->cifre=calloc(s->num_cifre,sizeof(char));
      riporto=0;
      for(j=0; j < s->num_cifre ;j++)
	{
          int cifraa,cifrab;
	  differenza=cifraa=cifrab=0;
	  if (a->num_cifre-j>0)
	    cifraa = a->cifre[a->num_cifre-1-j]-0x30;
	  if (b->num_cifre-j>0)
	    cifrab = b->cifre[b->num_cifre-1-j]-0x30;          
          if (cifraa > cifrab)
	    {
             differenza = cifraa-cifrab-riporto;
             riporto=0;
            }
          else if (cifraa == cifrab)
            {
	      if (riporto)
		differenza=9;
              riporto=1;
            }
          else
            {
	      differenza=cifraa-cifrab+10-riporto;
              riporto=1;
             }
	  s->cifre[s->num_cifre-1-j]=differenza+0x30;
	 }
       s->segno=a->segno;
        
      return s;
    }
}
  
/* facciamo adesso una funzione che mi permette di stampare la struttura che si  creato con la funzione precedente */


void print_num(struct numero *a)
{
  
  int j;
  if(a->segno <0)
    printf("-");  /* si stampa prima il segno */ 
  else
    printf("+");
  for(j=0;j<a->num_cifre;j++)
    printf("%c",a->cifre[j]);
  
}



/*
  
/* facciamo adesso il programma principale per vedere se si  fatto le cose correttamente */


main(int argc, char **argv)
{
  struct numero *a, *b;
  int i;
  a=crea_num(argv[1]);
  b=crea_num(argv[2]);
  printf("\n\nLa somma dei numeri immessi da linea di comando e' \n");
  print_num(a);
  printf("\n+\n");
  print_num(b);
  printf("=\n");
  print_num(sum_num(a,b));
  printf("\n\n");
}
