#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <unistd.h>

main(int argc,char **argv)
{
  if (fork())
    {      /* parent */
     struct termios termio;
     int fdterm,fdterm2;
     if(*(argv[1]) == '/')
      {
      if((fdterm=open(argv[1],O_RDONLY)) == -1)
       {
        perror(argv[1]);
        exit(1);
       }
      else
        printf("%s open\n",argv[1]);
      }
     else if(*argv[1] == '0') 
      {
       fdterm=*argv[1]-0x30;
       printf("file descriptor=%c\n",*argv[1]);
      }
     else
      {
       printf("no valid file descriptor or device name\n");
       exit(1); 
      }
     if (tcgetattr(fdterm,&termio) == -1)
      {
       perror("get attributes");
       exit(1);
      }
     //  printf("c_iflag=%11.11o\nc_oflag=%11.11o\nc_cflag=%11.11o\nc_lflag=%11.11o\n",termio.c_iflag,termio.c_oflag,termio.c_cflag,termio.c_lflag);
  
     cfmakeraw(&termio);

     if (tcsetattr(fdterm,TCSANOW,&termio) == -1)
      {
       perror("set attributes");
       exit(1);
      }

 
     if(*(argv[2]) == '/')
      {
       if((fdterm2=open(argv[2],O_WRONLY)) == -1)
        {
         perror(argv[2]);
         exit(1);
        }
       else
        printf("%s open\n",argv[2]);
      }
     else if(*argv[2] == '1') 
      {
       fdterm2=*argv[2]-0x30;
       printf("file descriptor=%c\n",*argv[2]);
       }
     else
      {
       printf("no valid file descriptor or device name\n");
       exit(1); 
      }
     if (tcgetattr(fdterm2,&termio) == -1)
      {
        perror("get attributes 2");
        exit(1);
       }
  // printf("c_iflag=%11.11o\nc_oflag=%11.11o\nc_cflag=%11.11o\nc_lflag=%11.11o\n",termio.c_iflag,termio.c_oflag,termio.c_cflag,termio.c_lflag);
  
     cfmakeraw(&termio);

     if (tcsetattr(fdterm2,TCSANOW,&termio) == -1)
      {
       perror("set attributes 2");
       exit(1);
      }
     while(1)
      { char carattere;
        read(fdterm,&carattere,1);
        if (carattere == 1) break;
        write(fdterm2,&carattere,1);
       }
    }
  else
    {
      /* child */
     struct termios termio;
     int fdterm,fdterm2;
     if(*(argv[1]) == '/')
      {
      if((fdterm=open(argv[1],O_WRONLY)) == -1)
       {
        perror(argv[1]);
        exit(1);
       }
      else
        printf("%s open\n",argv[1]);
      }
     else if(*argv[1] == '0') 
      {
       fdterm=*argv[1]-0x30+1;
       printf("file descriptor=%c\n",*argv[1]);
      }
     else
      {
       printf("no valid file descriptor or device name\n");
       exit(1); 
      }
     if (tcgetattr(fdterm,&termio) == -1)
      {
       perror("child get attributes");
       exit(1);
      }
     //  printf("c_iflag=%11.11o\nc_oflag=%11.11o\nc_cflag=%11.11o\nc_lflag=%11.11o\n",termio.c_iflag,termio.c_oflag,termio.c_cflag,termio.c_lflag);
  
     cfmakeraw(&termio);

     if (tcsetattr(fdterm,TCSANOW,&termio) == -1)
      {
       perror("child set attributes");
       exit(1);
      }

 
     if(*(argv[2]) == '/')
      {
       if((fdterm2=open(argv[2],O_RDONLY)) == -1)
        {
         perror(argv[2]);
         exit(1);
        }
       else
        printf("%s open\n",argv[2]);
      }
     else if(*argv[2] == '1') 
      {
       fdterm2=*argv[2]-0x30-1;
       printf("file descriptor=%c\n",*argv[2]);
       }
     else
      {
       printf("no valid file descriptor or device name\n");
       exit(1); 
      }
     if (tcgetattr(fdterm2,&termio) == -1)
      {
        perror("get attributes 2");
        exit(1);
       }
  // printf("c_iflag=%11.11o\nc_oflag=%11.11o\nc_cflag=%11.11o\nc_lflag=%11.11o\n",termio.c_iflag,termio.c_oflag,termio.c_cflag,termio.c_lflag);
  
     cfmakeraw(&termio);

     if (tcsetattr(fdterm2,TCSANOW,&termio) == -1)
      {
       perror("set attributes 2");
       exit(1);
      }
     while(1)
      { char carattere;
        read(fdterm2,&carattere,1);
        if (carattere == 1) break;
        write(fdterm,&carattere,1);
       }
    }

}
