#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

struct matrix {
               int r;
               int c;
               double *m;
                 };


struct matrix *crea_mat(int righe, int colonne)
{
  struct matrix *mat;
  mat=(struct matrix *)calloc(1,sizeof(struct matrix));
  mat->r=righe;
  mat->c=colonne;
  mat->m=(double *)calloc(righe*colonne,sizeof(double));
  return mat;
}

int PutElem(int i,int j, struct matrix *a, double value)
{
  if (i < 0 || i >= a->r)
    return -1;
  if (j < 0 || j >= a->c)
    return -1;
  a->m[i*a->c+j]=value;
  return 0;

    // m[10][20]     m[5][7]   5*20+7
}

int GetElem(int i,int j, struct matrix *a, double *addr_value)
{
  if (i < 0 || i >= a->r)
    return -1;
  if (j < 0 || j >= a->c)
    return -1;
  *addr_value=a->m[i*a->c+j];
  return 0;

    // m[10][20]     m[5][7]   5*20+7
}

void print_mat(struct matrix *m)
{
  int i,j;
  for (i = 0 ; i < m->r ; i++)
    {
    for (j = 0 ; j < m->c ; j++)
      {
        double value;
	GetElem(i,j,m,&value);
        printf("%lg ",value);
       }
    printf("\n");
    }
}




main()
{
  int i,j;  
  int j_max=0;
  struct matrix *m;
  for(i=0 ;; i++)
    {
     for (j=1 ; ; j++)
      {
       char numero[30];
       if(scanf("%s",numero) == EOF) goto esci;
       if (numero[strlen(numero)-1] == ';')
        break;
      }
     printf("i=%d j=%d\n",i,j);
     if (j > j_max) j_max=j;
    }
 esci:
  lseek(0,0,SEEK_SET);
  m=crea_mat(i,j_max);
  for (i=0 ;;i++) 
    {
     int flag_fine=1;
      for (j=0 ;flag_fine; j++)
	{
         char numero[30];
         double value;
         if(scanf("%s",numero) == EOF) goto esci1;
         if (numero[strlen(numero)-1] == ';')
	   {
	     numero[strlen(numero)-1]=0;
             flag_fine=0;
	   }
         sscanf(numero,"%lg",&value);
         if (PutElem(i,j,m,value) < 0)
	   {
	     printf("errore elem(%d,%d) %lg\n",i,j,value);
             return;
	   }
	}

    }
 esci1:
  print_mat(m);
}
