#include<stdio.h>
#include<stdlib.h>

struct mat {
  int n;
  int m;
  double *a;
};


struct mat *newm(int n, int m)
{
  struct mat *c;
  c=(struct mat *)calloc(1, sizeof(struct mat));

  c->n=n;
  c->m=m;
  c->a=(double *)calloc(n*m, sizeof(double));

  return c;
}

struct mat *readm(int n, int m, double *valori)
{
  int j;
  struct mat *r;
  r=newm(n,m);

  for(j=0;j<(n*m); j++)
  r->a[j]=valori[j];

  return r;

}


void printm(struct mat *r)
{
  int j,k;

  for(j=0; j<r->n; j++)
    {
      printf("%3.3d  ",j);
      for(k=0; k<r->m; k++)
	printf("%lg ",r->a[j*(r->m)+k]);
      printf("\n");


    }

}

struct mat *prodotto(struct mat *A, struct mat *B)
{
  int j, i, l;
  double ele=0., aux=0.;
  struct mat *p;

  if((A->m)!=(B->n)) 
    {
     printf("Matrici incompatibili\n");
     return NULL;
    }

  else
    {

     p=newm(A->n,B->m);

     for(j=0; j<(A->n); j++)
      {
	// for (i=0; i<(A->m); i++)
       for (i=0; i<(B->m); i++)
	 {
	   for (l=0; l<(A->m); l++)
	    {
	      // aux=(ele+((A->a[j*(A->m)+l])*(B->a[l*(B->n)+i])));
	      // printf("%lg\n",ele);
              printf("%lg  %lg\n",A->a[j*(A->m)+l],B->a[l*(B->m)+i]);
	      ele+=((A->a[j*(A->m)+l])*(B->a[l*(B->m)+i]));

	    }
	  p->a[j*(p->m)+i]=ele;
	  //printf("%lg\n", p->a[j*(A->m)+i]);
	  ele=0.;
	  //	  aux=0.;

	}

    }

  return p;
    }
}







int main(int argc, char **argv)
{
  int righe_A, righe_B, colonne_A, colonne_B, j, i;
  double *v_A, *v_B;
  struct mat *A, *B;

  printf("\n Inserire numero di righe e colonne matrice A\n");
  scanf("%d%d", &righe_A, &colonne_A);

  v_A=(double *)calloc(righe_A*colonne_A, sizeof(double));

  printf("\n Inserire elementi matrice A\n");
  for(j=0; j<righe_A*colonne_A; j++)
    scanf("%lg", &v_A[j]);

  A=readm(righe_A,colonne_A,v_A);


 printf("\n Inserire numero di righe e colonne matrice B\n");
  scanf("%d%d", &righe_B, &colonne_B);

  v_B=(double *)calloc(righe_B*colonne_B, sizeof(double));

  printf("\n Inserire elementi matrice B\n");
  for(i=0; i<righe_B*colonne_B; i++)
    scanf("%lg", &v_B[i]);

  B=readm(righe_B,colonne_B,v_B);

  printf("\n\n");
  printm(A);
  printf("\n\n");
  printm(B);
  printf("\n\n");

  printm(prodotto(A,B));

}
