//definiamo la struttura matrice
struct matrix {
               double *a;  //indirizzo di dove si trovano i dati della matrice
               int r;  //numero di righe
               int c;  //numero di colonne
              };



struct matrix *new_mat(int righe, int colonne)
{
  struct matrix *amatrix;

  amatrix = (struct matrix *)calloc(1,sizeof(struct matrix));
  amatrix->a = (double *)calloc(righe*colonne, sizeof(double));
  amatrix->r = righe;
  amatrix->c = colonne;  

  return (amatrix);

}

void stampa(struct matrix *m)
{
  int i,j;
  
  printf("Matrice %d x %d\n", m->r, m->c);
  
  for(i=0; i < m->r; i++)
    {
      for (j=0; j < m->c; j++)
	printf("%lg%c", m->a[i*m->c+j],j%10 == 9 ? '\n' : ' ');
      printf("\n");
    }
  return;
}

/* Scrivo la funzione det che calcola il determinante della matrice */
double det(struct matrix *m)            
{
  double D; //questa  la variabile determinante 

  D=m->a[0]*m->a[3]-m->a[1]*m->a[2];
  return D;
  /* printf("Determinante = %lg\n", D); */

}


main()
{
  int righe, colonne, i;
  struct matrix *m;
  double d;

 /*  printf ("Inserisci righe e colonne: "); */
  scanf ("%d %d", &righe, &colonne);
  printf ("Matrice letta: righe= %d colonne= %d\n", righe,colonne);

if (righe != colonne)
    printf("La matrice inserita non e' una matrice quadrata!\n");

  m = new_mat(righe,colonne);

  for (i=0; i<righe*colonne;i++)
    scanf("%lg",&(m->a[i]));
 
  stampa (m);
  d=det(m);
  
  printf ("Determinante = %lg\n", d);

}

