#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <termios.h>

/*#define IGNBRK  0000001 (1 << 0)
  #define BRKINT  0000002 (1 << 1)
  #define IGNPAR  0000004 (1 << 2)
  #define PARMRK  0000010 (1 << 3)
  #define INPCK   0000020 (1 << 4)
  #define ISTRIP  0000040 (1 << 5)
  #define INLCR   0000100
  #define IGNCR   0000200
  #define ICRNL   0000400
  #define IUCLC   0001000
  #define IXON    0002000
  #define IXANY   0004000
  #define IXOFF   0010000
  #define IMAXBEL 0020000
*/


main(int argc,char **argv)
{
  struct termios terminale;
  int file_des;
  if (argc < 2)
    {
      printf("help:  %s nomefile\n",argv[0]);
      exit(1);
     }
  if ((file_des=open(argv[1],O_WRONLY)) < 0)
    {
     perror("apertura device");
     exit(1);
    }
  tcgetattr(file_des,&terminale);
  printf("c_iflag=%11.11o c_oflag=%11.11o c_cflag=%11.11o c_lflag=%11.11o\n",
         terminale.c_iflag,terminale.c_oflag,terminale.c_cflag,terminale.c_lflag);
  cfmakeraw(&terminale);    
  tcsetattr(file_des,TCSANOW,&terminale);
  tcgetattr(file_des,&terminale);
  printf("c_iflag=%11.11o c_oflag=%11.11o c_cflag=%11.11o c_lflag=%11.11o\n",
         terminale.c_iflag,terminale.c_oflag,terminale.c_cflag,terminale.c_lflag);
  getchar();
/*
   {
     int a[1000];
     char format[100];
     int i;
     for (i = 0 ; i < 1000 ; i++)
       {
         a[i] = i;
 	sprintf(format,"%4.4d ",a[i]);
 	write(file_des,format,5); 
        }
   
  }
    */ 
 
}
