main()
{
  unsigned int numero = 112565; /* 0000 0000 0000 0001 1011 0111 1011 0100 0x0001B7B4 */
                       /* 0000 0000 0000 0000 0000 0000 0000 1111 */

  /*

   A     B (A & B)  ~(A & B) (A | B) ~(A | B) (A ^ B) ~(A ^ B)

   0     0    0        1       0       1         0        1
   0     1    0        1       1       0         1        0
   1     0    0        1       1       0         1        0
   1     1    1        0       1       0         0        1


 >>  <<
 
     c7 = (numero & 0xf0000000) >> 28;
     c6 = (numero & 0x0f000000) >> 24;
     c5 = (numero & 0x00f00000) >> 20;
     c4 = (numero & 0x000f0000) >> 16;
  */
  char c[8];
  int i,num,res;
  for (i = 0 ; i < 8 ; i++)
    {
      c[i] = (numero & (0xf0000000 >> i*4)) >> (28 - i*4);
      if (c[i] < 10) 
        c[i] += 0x30;
      else
        c[i] = c[i] + 0x37;
      printf("%c",c[i]);      
     }
  printf("\n");

  /* calcolo parity bit 

   0101 & 0001

   0001  res=0001

   0101 & 0010 

   0000  res=0001 ^ 0000 = 0001

   0101 & 0100

   0100  reas=0001 ^ 0100 = 0101
*/
  res = 0;
  for (i = 0 ; i < 32 ; i++) 
       res ^= ((numero >> i) & 1); 
  printf("parity bit =%d\n",res);
}
