#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <errno.h>

main()
{
  if( fork() )
    { /* programma parent */
     int fd_out;
     struct termios mio_termios;
     char byte;
 
     if ( tcgetattr(0, &mio_termios) < 0)
       {
        perror("tcgetattr stdin");
        exit(1);
       } 
     cfmakeraw(&mio_termios);
     if ( tcsetattr(0,TCSANOW,&mio_termios) < 0)
       {
        perror("tcsetattr stdin");
        exit(1);
        }
     if((fd_out = open("/dev/ttyS0",O_WRONLY)) < 0)
       {
        perror("open /dev/ttyS0");
        exit(1);
        }
  
     if ( tcgetattr(fd_out, &mio_termios) < 0)
       {
        perror("tcgetattr term");
        exit(1);
       } 
     cfmakeraw(&mio_termios);
     if ( tcsetattr(fd_out,TCSANOW,&mio_termios) < 0)
       {
        perror("tcsetattr term" );
        exit(1);
       }
     while(1)
      {
       read(0,&byte,1);
       write(fd_out,&byte,1);
       if (byte == '&') break;
      }
     }
  else
    { /* programma child */
     int fd_in;
     struct termios mio_termios;
     char byte;
 
     if((fd_in = open("/dev/ttyS0",O_RDONLY)) < 0)
       {
        perror("open /dev/ttyS0");
        exit(1);
       }
  
     if ( tcgetattr(fd_in, &mio_termios) < 0)
       {
        perror("tcgetattr term");
        exit(1);
       } 
     cfmakeraw(&mio_termios);
     if ( tcsetattr(fd_in,TCSANOW,&mio_termios) < 0)
       {
        perror("tcsetattr term" );
        exit(1);
       }
     if ( tcgetattr(1, &mio_termios) < 0)
       {
        perror("tcgetattr stdout");
        exit(1);
       } 
     cfmakeraw(&mio_termios);
     if ( tcsetattr(1,TCSANOW,&mio_termios) < 0)
       {
        perror("tcsetattr stdin");
        exit(1);
       }
     while(1)
     {
      read(fd_in,&byte,1);
      write(1,&byte,1);
      if (byte == '&') break;
     }
   }
}
