#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>

main()
{
  int pid;
  if ((pid = fork()))
    {
     int fdin;
     struct termios term_struct;
     /* parent process */
     printf("parent process %d\n",pid);
     if ( (fdin=open("/dev/ttyS0",O_RDONLY)) < 0)
      {
        perror("open");
        exit(1);
      }
     if (tcgetattr(fdin,&term_struct) < 0)
      {
       perror("tcgetattr");
       exit(1);
      }
     cfmakeraw(&term_struct);
     if (tcsetattr(fdin,TCSANOW,&term_struct) < 0)
      {
       perror("tcsetattr");
       exit(1);
      }

     if (tcgetattr(1,&term_struct) < 0)
      {
       perror("tcgetattr");
       exit(1);
      }
     cfmakeraw(&term_struct);
     if (tcsetattr(1,TCSANOW,&term_struct) < 0)
      {
       perror("tcsetattr");
       exit(1);
       }
     while(1)
      {
       char carattere;
       read(fdin,&carattere,1);
       write(1,&carattere,1);
       if (carattere == '&') break;
      }
    }
  else
    {
      /* child process */
     int fdout;
     struct termios term_struct;
     printf("child process %d\n",pid);
     if (tcgetattr(0,&term_struct) < 0)
      {
       perror("tcgetattr");
       exit(1);
      }
     cfmakeraw(&term_struct);
     if (tcsetattr(0,TCSANOW,&term_struct) < 0)
      {
       perror("tcsetattr");
       exit(1);
      }
     if ( (fdout=open("/dev/ttyS0",O_WRONLY)) < 0)
      {
        perror("open");
        exit(1);
      }
     if (tcgetattr(fdout,&term_struct) < 0)
      {
       perror("tcgetattr");
       exit(1);
       }
     cfmakeraw(&term_struct);
     if (tcsetattr(fdout,TCSANOW,&term_struct) < 0)
      {
       perror("tcsetattr");
       exit(1);
      }
     while(1)
      {
       char carattere;
       read(0,&carattere,1);
       write(fdout,&carattere,1);
       if (carattere == '&') break;
      }
   }
}
