#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <errno.h>
main(int argc, char **argv)
{
 if (fork())
   {             /* parent */
  struct termios term;
  int fdterm,fdterm2;
  if (*(argv[1]) == '0')
    fdterm=*argv[1]-0x30;
  else
    { 
      if ((fdterm=open(argv[1],O_RDONLY)) == -1)
        {
	  perror(argv[1]);
          exit(1);
         }
     }
  if (tcgetattr(fdterm,&term) == -1)
    {
      perror("getattr");
      exit(1);
     }

  printf("c_iflag=%11.11o\nc_oflag=%11.11o\nc_cflag=%11.11o\nc_lflag=%11.11o\n",term.c_iflag,term.c_oflag,term.c_cflag,term.c_lflag);
  cfmakeraw(&term);
  if (tcsetattr(fdterm,TCSANOW,&term) == -1)
    {
      perror("setattr");
      exit(1);
     }

  if ((fdterm2=open(argv[2],O_WRONLY)) == -1)
        {
	  perror(argv[2]);
          exit(1);
         }

  if (tcgetattr(fdterm2,&term) == -1)
    {
      perror("getattr2");
      exit(1);
     }

  //printf("c_iflag=%11.11o\nc_oflag=%11.11o\nc_cflag=%11.11o\nc_lflag=%11.11o\n",term.c_iflag,term.c_oflag,term.c_cflag,term.c_lflag);
  cfmakeraw(&term);
  if (tcsetattr(fdterm2,TCSANOW,&term) == -1)
    {
      perror("setattr2");
      exit(1);
     }
  while(1)
    { char carattere;
      read(fdterm,&carattere,1);
      if (carattere == 1) break;
      write(fdterm2,&carattere,1);
   }
 } 
else
 {             /* child */
  struct termios term;
  int fdterm,fdterm2;
  if (*(argv[1]) == '0')
    fdterm=*argv[1]-0x30+1;
  else
    { 
      if ((fdterm=open(argv[1],O_WRONLY)) == -1)
        {
	  perror(argv[1]);
          exit(1);
         }
     }
  if (tcgetattr(fdterm,&term) == -1)
    {
      perror("child getattr");
      exit(1);
     }

  printf("c_iflag=%11.11o\nc_oflag=%11.11o\nc_cflag=%11.11o\nc_lflag=%11.11o\n",term.c_iflag,term.c_oflag,term.c_cflag,term.c_lflag);
  cfmakeraw(&term);
  if (tcsetattr(fdterm,TCSANOW,&term) == -1)
    {
      perror("child setattr");
      exit(1);
     }

  if ((fdterm2=open(argv[2],O_RDONLY)) == -1)
        {
	  perror(argv[2]);
          exit(1);
         }

  if (tcgetattr(fdterm2,&term) == -1)
    {
      perror("child getattr2");
      exit(1);
     }

  //printf("c_iflag=%11.11o\nc_oflag=%11.11o\nc_cflag=%11.11o\nc_lflag=%11.11o\n",term.c_iflag,term.c_oflag,term.c_cflag,term.c_lflag);
  cfmakeraw(&term);
  if (tcsetattr(fdterm2,TCSANOW,&term) == -1)
    {
      perror("child setattr2");
      exit(1);
     }
  while(1)
    { char carattere;
      read(fdterm2,&carattere,1);
      if (carattere == 1) break;
      write(fdterm,&carattere,1);
   }
 } 



}
